/*
 * reorderPlugins.java
 *
 * Created on July 16, 2003, 3:01 PM
 */

import java.awt.Cursor;
import java.awt.event.KeyEvent;
import java.awt.event.WindowEvent;
import java.io.File;
import java.io.FilenameFilter;
import java.io.IOException;
import java.util.Arrays;
import java.util.Comparator;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;

/**
 *
 * @author  sjakab
 */
public class reorderPlugins extends javax.swing.JDialog {

    public class esmFilter implements FilenameFilter
    {
        public boolean accept(File dir, String name)
        {
            return name.endsWith(".esm");
        }
    }

    public class espFilter implements FilenameFilter
    {
        public boolean accept(File dir, String name)
        {
            return name.endsWith(".esp");
        }
    }

    public class sortByTime implements Comparator
    {
        public int compare(Object o1, Object o2)
        {
            File f1 = (File)o1;
            File f2 = (File)o2;
            return (int)(f1.lastModified() - f2.lastModified());
        }
    }

	public class listFile extends File
	{
		public listFile(File source)
		{
			super(source, "");
		}

		public String toString()
		{
			return getName();
		}
	}
	
    /** Creates new form reorderPlugins */
    public reorderPlugins(java.awt.Frame parent, boolean modal) 
	{
        super(parent, modal);
        initComponents();

		// load the esp list based on the Morrowind registry key
        loadEsps();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents()//GEN-BEGIN:initComponents
    {
        java.awt.GridBagConstraints gridBagConstraints;

        jScrollPane1 = new javax.swing.JScrollPane();
        jList1 = new javax.swing.JList();
        jTextField1 = new javax.swing.JTextField();
        jButton5 = new javax.swing.JButton();
        jPanel3 = new javax.swing.JPanel();
        jPanel2 = new javax.swing.JPanel();
        jButton1 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();
        jPanel1 = new javax.swing.JPanel();
        jButton3 = new javax.swing.JButton();
        jButton4 = new javax.swing.JButton();

        getContentPane().setLayout(new java.awt.GridBagLayout());

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Test");
        setModal(true);
        addWindowListener(new java.awt.event.WindowAdapter()
        {
            public void windowClosing(java.awt.event.WindowEvent evt)
            {
                closeDialog(evt);
            }
        });

        jScrollPane1.setHorizontalScrollBarPolicy(javax.swing.JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
        jScrollPane1.setVerticalScrollBarPolicy(javax.swing.JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
        jScrollPane1.setMaximumSize(new java.awt.Dimension(1024, 768));
        jScrollPane1.setMinimumSize(new java.awt.Dimension(274, 300));
        jScrollPane1.setPreferredSize(new java.awt.Dimension(274, 300));
        jList1.setBorder(new javax.swing.border.EtchedBorder());
        jList1.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        jScrollPane1.setViewportView(jList1);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.ipadx = 6;
        gridBagConstraints.ipady = 169;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(13, 13, 11, 0);
        getContentPane().add(jScrollPane1, gridBagConstraints);

        jTextField1.addKeyListener(new java.awt.event.KeyAdapter()
        {
            public void keyReleased(java.awt.event.KeyEvent evt)
            {
                jTextField1KeyReleased(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipadx = 366;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(10, 10, 0, 47);
        getContentPane().add(jTextField1, gridBagConstraints);

        jButton5.setText("...");
        jButton5.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                jButton5ActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.ipadx = -23;
        gridBagConstraints.ipady = -6;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHEAST;
        gridBagConstraints.insets = new java.awt.Insets(10, 97, 0, 17);
        getContentPane().add(jButton5, gridBagConstraints);

        jPanel3.setLayout(new java.awt.GridBagLayout());

        jPanel3.setBorder(new javax.swing.border.LineBorder((java.awt.Color) javax.swing.UIManager.getDefaults().get("Button.background")));
        jPanel3.setMaximumSize(new java.awt.Dimension(101, 768));
        jPanel3.setMinimumSize(new java.awt.Dimension(101, 300));
        jPanel3.setPreferredSize(new java.awt.Dimension(101, 300));
        jPanel2.setLayout(null);

        jPanel2.setMaximumSize(new java.awt.Dimension(100, 55));
        jPanel2.setMinimumSize(new java.awt.Dimension(100, 55));
        jButton1.setText("Move up");
        jButton1.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                jButton1ActionPerformed(evt);
            }
        });

        jPanel2.add(jButton1);
        jButton1.setBounds(0, 0, 100, 26);

        jButton2.setText("Move down");
        jButton2.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                jButton2ActionPerformed(evt);
            }
        });

        jPanel2.add(jButton2);
        jButton2.setBounds(0, 30, 100, 26);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.ipadx = 99;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        jPanel3.add(jPanel2, gridBagConstraints);

        jPanel1.setLayout(null);

        jPanel1.setMaximumSize(new java.awt.Dimension(100, 55));
        jPanel1.setMinimumSize(new java.awt.Dimension(100, 55));
        jButton3.setText("OK");
        jButton3.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                jButton3ActionPerformed(evt);
            }
        });

        jPanel1.add(jButton3);
        jButton3.setBounds(0, 0, 100, 25);

        jButton4.setText("Cancel");
        jButton4.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                jButton4ActionPerformed(evt);
            }
        });

        jPanel1.add(jButton4);
        jButton4.setBounds(0, 30, 100, 25);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.ipadx = 99;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.SOUTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        jPanel3.add(jPanel1, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.VERTICAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHEAST;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(10, 17, 14, 17);
        getContentPane().add(jPanel3, gridBagConstraints);

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-427)/2, (screenSize.height-354)/2, 427, 354);
    }//GEN-END:initComponents

    private void jTextField1KeyReleased(java.awt.event.KeyEvent evt)//GEN-FIRST:event_jTextField1KeyReleased
    {//GEN-HEADEREND:event_jTextField1KeyReleased
		// Add your handling code here:
		if (evt.getKeyChar() == '\n')
		{
			File dataDir = new File(jTextField1.getText());
			if (dataDir.exists())
			{
				setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
				repaint();
				loadEsps(dataDir);
				setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
				repaint();
			}
			else
			{
				JOptionPane.showMessageDialog(this, "Directory does not exist");
			}
		}
    }//GEN-LAST:event_jTextField1KeyReleased

    private void jButton5ActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_jButton5ActionPerformed
    {//GEN-HEADEREND:event_jButton5ActionPerformed
		// Add your handling code here:
		// allow user to pick a directory
		chooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
		chooser.setCurrentDirectory(new File(jTextField1.getText()));
		int returnVal = chooser.showOpenDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION)
		{
			setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
			repaint();
			loadEsps(chooser.getSelectedFile());
			setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
			repaint();
		}
    }//GEN-LAST:event_jButton5ActionPerformed

    private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
        // Add your handling code here:
        // reset the timestamps of the esp files based on the newest esm file
        long oldestEsmTime = 0;
        for (int i = 0; i < esmFiles.length; ++i)
        {
            if (esmFiles[i].lastModified() > oldestEsmTime)
                oldestEsmTime = esmFiles[i].lastModified();
        }
        for (int i = 0; i < espFiles.length; ++i)
        {
            espFiles[i].setLastModified(oldestEsmTime + (i+1) * 2000);
        }
		JOptionPane.showMessageDialog(this, "Files reordered");
		closeDialog(new WindowEvent(this, WindowEvent.WINDOW_CLOSING));
    }//GEN-LAST:event_jButton3ActionPerformed

    private void jButton4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton4ActionPerformed
        // Add your handling code here:
		closeDialog(new WindowEvent(this, WindowEvent.WINDOW_CLOSING));
    }//GEN-LAST:event_jButton4ActionPerformed

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        // Add your handling code here:
        // Move up
        if (jList1.getValueIsAdjusting())
            return;

        jList1.setValueIsAdjusting(true);
        int selected = jList1.getSelectedIndex();
        if (selected == -1 || selected == 0)
        {
            jList1.setValueIsAdjusting(false);
            return;
        }
        int newSelected = selected - 1;

        listFile temp = espFiles[newSelected];
        espFiles[newSelected] = espFiles[selected];
        espFiles[selected] = temp;

        jList1.setListData(espFiles);
        jList1.setSelectedIndex(newSelected);
        jList1.ensureIndexIsVisible(newSelected);
        jList1.setValueIsAdjusting(false);
    }//GEN-LAST:event_jButton1ActionPerformed

    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        // Add your handling code here:
        // Move down
        if (jList1.getValueIsAdjusting())
            return;

        jList1.setValueIsAdjusting(true);
        int selected = jList1.getSelectedIndex();
        if (selected == -1 || selected == espFiles.length - 1)
        {
            jList1.setValueIsAdjusting(false);
            return;
        }
        int newSelected = selected + 1;

        listFile temp = espFiles[newSelected];
        espFiles[newSelected] = espFiles[selected];
        espFiles[selected] = temp;

        jList1.setListData(espFiles);
        jList1.setSelectedIndex(newSelected);
        jList1.ensureIndexIsVisible(newSelected);
        jList1.setValueIsAdjusting(false);
    }//GEN-LAST:event_jButton2ActionPerformed

    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible(false);
        dispose();
    }//GEN-LAST:event_closeDialog

    private boolean loadEsps()
    {
        String path = getMWInstallPath();
        if (path == null)
            return false;

        File mwDir = new File(path);
        if (!mwDir.isDirectory())
            return false;

        File dataDir = new File(path, "Data Files");
        if (!dataDir.isDirectory())
            return false;

		return loadEsps(dataDir);
    }

    private boolean loadEsps(File dataDir)
    {
		if (!dataDir.exists())
		{
			return false;
		}

		// get the esm and esp files from the data dir
		File[] tempFiles = dataDir.listFiles(new esmFilter());
		if (tempFiles != null)
		{
			esmFiles = new listFile[tempFiles.length];
			for (int i = 0; i < tempFiles.length; ++i)
				esmFiles[i] = new listFile(tempFiles[i]);
		}
		
		tempFiles = dataDir.listFiles(new espFilter());
		if (tempFiles != null)
		{
			espFiles = new listFile[tempFiles.length];
			for (int i = 0; i < tempFiles.length; ++i)
				espFiles[i] = new listFile(tempFiles[i]);
		}
		
		if (esmFiles != null && esmFiles.length > 1)
			Arrays.sort(esmFiles, new sortByTime());
		if (espFiles != null && espFiles.length > 1)
			Arrays.sort(espFiles, new sortByTime());
        jList1.setListData(espFiles);
        jTextField1.setText(dataDir.getPath());
        return true;
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) 
	{
        new reorderPlugins(new javax.swing.JFrame(), true).show();
		System.out.println("done");
		System.exit(0);
    }

    private native String getMWInstallPath();
    static
    {
        try
        {
            String libpath = System.getProperty("java.library.path");
            File curdir = new File(".");
            libpath = curdir.getCanonicalPath() + File.pathSeparatorChar + libpath;
            System.setProperty("java.library.path", libpath);
			//System.out.println(libpath);
        }
        catch (IOException err)
        {
        }
        System.loadLibrary("getmwinstall");
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JButton jButton4;
    private javax.swing.JButton jButton5;
    private javax.swing.JList jList1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextField jTextField1;
    // End of variables declaration//GEN-END:variables

    private listFile[] esmFiles = null;
    private listFile[] espFiles = null;
    JFileChooser chooser = new JFileChooser();
}
